/* Bezier curve yay */

#include "bezier.h"

static Vector PBez3D(Vector* cp, float t)
{
	Vector a, b, c, result;
	float t2, t3;

	c.x = 3.0 * (cp[1].x - cp[0].x);
	b.x = 3.0 * (cp[2].x - cp[1].x) - c.x;
	a.x = cp[3].x - cp[0].x - c.x - b.x;

	c.y = 3.0 * (cp[1].y - cp[0].y);
	b.y = 3.0 * (cp[2].y - cp[1].y) - c.y;
	a.y = cp[3].y - cp[0].y - c.y - b.y;

	c.z = 3.0 * (cp[1].z - cp[0].z);
	b.z = 3.0 * (cp[2].z - cp[1].z) - c.z;
	a.z = cp[3].z - cp[0].z - c.z - b.z;

	t2 = t * t;
	t3 = t2 * t;

	result.x = (a.x * t3) + (b.x * t2) + (c.x * t) + cp[0].x;
	result.y = (a.y * t3) + (b.y * t2) + (c.y * t) + cp[0].y;
	result.z = (a.z * t3) + (b.z * t2) + (c.z * t) + cp[0].z;

	return result;
}

void CompBez(Vector* cp, int numPoints, Vector* curve)
{
	float t, dt;
	int i;

	dt = 1.0 / ( numPoints - 1 );
	for(i = 0, t = 0; i < numPoints; i++, t += dt)
	{
		curve[i] = PBez3D(cp, t);
	}
}
