/*
graphics.h
contains non-crossplatform includes
and graphics related variables&functions
*/

#ifndef GRAPHICS_H
#define GRAPHICS_H

#ifndef OS_X
#ifdef SDL
#include <SDL/SDL.h>
#else
#include <windows.h>
#define WIN32_LEAN_AND_MEAN
#endif
#include <GL/gl.h>
#include <GL/glu.h>
#else
#include <SDL.h>
#include <gl.h>
#include <glu.h>
#endif

#include <math.h>
#include <stdlib.h>

const int window_width = 640;
const int window_height = 480;

void viewReset(void);
void view2D(int w, int h);
void view3D(void);
void drawCircle(float x, float y, float z, float r);

#endif
