#include <stdio.h>
#include <stdlib.h>
#include "graphics.h"
#include "sound.h"
#include "timer.h"
#include "scene.h"

#include "effects/BeginFunk.h"

#define MAX_SCENES 1
Scene* scene[MAX_SCENES];

static void effectInit(void)
{
	//put all the effects _here_ ...engine will do the rest
	//it's allowed to make simultaneous scenes (time overlapping)

	//first value in the scene initializer is
	//the begin time and second is the end time
	//(both are in milliseconds)

	scene[0] = new BeginFunk(0, 10000);
}

bool done = false;
const int demoEnd = 100000;
#ifdef SDL
SDL_Event event;
#endif



static void draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	viewReset();

	for(int i = 0; i < MAX_SCENES; i++)
	{
		scene[i]->update();
	}

#ifdef SDL
	SDL_GL_SwapBuffers();
#endif
}

static void init(void)
{
#ifdef SDL
	SDL_Init(SDL_INIT_VIDEO);

#ifdef FULLSCREEN
	SDL_SetVideoMode(window_width, window_height, 0, SDL_OPENGL|SDL_FULLSCREEN);
	SDL_ShowCursor(0);
#else
	SDL_SetVideoMode(window_width, window_height, 0, SDL_OPENGL);
	SDL_WM_SetCaption("ExHouse's Fuzzy Lhamas", 0);
#endif
#endif

	glLineWidth(1.0f);
	glPointSize(4.0f);
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
	//glBlendFunc (GL_SRC_ALPHA, GL_ONE);
	glClearColor(1,1,1,1);

	effectInit();

	sound.init();
	timer.init();
}

static void input(void)
{
#ifdef SDL
	SDL_PollEvent(&event);
	if ((event.key.keysym.sym == SDLK_ESCAPE) || (event.type == SDL_QUIT))
	{
		done = true;
	}
#endif
}

int main(int argc, char **argv)
{
Vector p = Vector(1,1,1);
Vector p2 = Vector(1,-1,1);
Vector p3 = Vector(-1,-1,1);
float r = p2.distance(p);
printf("p -> %.2f %.2f %.2f\n",p.x,p.y,p.z);
printf("p2 -> %.2f %.2f %.2f\n",p2.x,p2.y,p2.z);
printf("r -> %.2f\n",r);
printf("angle -> %.2f\n",p.angle(p2));

/*void VectCreate (p3d_ptr_type p_start, p3d_ptr_type p_end, p3d_ptr_type p_vector)
{
    p_vector->x = p_end->x - p_start->x;
    p_vector->y = p_end->y - p_start->y;
    p_vector->z = p_end->z - p_start->z;
    VectNormalize(p_vector);
}

Vector t1;
t1.x = p2.x - p.x;
t1.y = p2.y - p.y;
t1.z = p2.z - p.z;
t1 = t1.normalize();
Vector t2;
t2.x = p3.x - p.x;
t2.y = p3.y - p.y;
t2.z = p3.z - p.z;
t2 = t2.normalize();
t1.dotProduct(t2);
t1 = t1.normalize();

We create two co-planar vectors using two sides of the polygon:

      VectCreate (&l_vect1, &l_vect2, &l_vect_b1);
      VectCreate (&l_vect1, &l_vect3, &l_vect_b2);

calculate the vector product between these vectors:

      VectDotProduct (&l_vect_b1, &l_vect_b2, &l_normal);

and normalize the resulting vector, this is the polygon normal:

      VectNormalize (&l_normal); 
*/


Vector normal = p.normal(p2, p3);
printf("normal -> %.2f %.2f %.2f\n", normal.x, normal.y, normal.z);

/*
Next up, we need to find the intersection point. This isn't a very difficult task. You have the start and end points of a "line" in 3-space (your "position" and "destination"), so subtract the start (position) from the end (destination) to get a direction vector that we'll call "ray". ray = destination minus position. Now, remember your linear algebra. A line in 3-space can be defined as follows:
  lx = start.x + (ray.x * t)
  ly = start.y + (ray.y * t)
  lz = start.z + (ray.z * t)

t = - ( DotProduct( plane->normal, start) + plane->distance )   /
          DotProduct( plane->normal, ray)

---
int TestIntersionPlane(const Plane& plane,const TVector& position,const TVector& direction, double& lamda, TVector& pNormal)
{
	double DotProduct=direction.dot(plane._Normal);			// Dot Product Between Plane Normal And Ray Direction
	double l2;

	// Determine If Ray Parallel To Plane
	if ((DotProduct<ZERO)&&(DotProduct>-ZERO))
		return 0;

	l2=(plane._Normal.dot(plane._Position-position))/DotProduct;	// Find Distance To Collision Point

	if (l2<-ZERO)							// Test If Collision Behind Start
		return 0;

	pNormal=plane._Normal;
	lamda=l2;
	return 1;
}
*/
//scalar p = DotProduct( plane->normal, destPt ) + plane->distance;
/*	double DotProduct=direction.dot(plane._Normal);
	if ((DotProduct<ZERO)&&(DotProduct>-ZERO)) return 0;
	l2=(plane._Normal.dot(plane._Position-position))/DotProduct;	// Find Distance To Collision Point
*/

//        pl1._Position=TVector(0,-300,0);
//        pl1._Normal=TVector(0,1,0);

Vector direction(0,-1,0);
Vector plnormal(0,1,0);
float test = direction.dotProduct(plnormal);
float l2 = plnormal.dotProduct(Vector(0,-300,0)-Vector(0,-250,0))/test;
printf("test -> %f %f\n",test,l2);

/*Vector tst(0,0,-3);
Vector terse = p+p2+p3;
float test = normal.dotProduct(tst) + normal.distance(tst);
printf("test -> %.2f %.2f %.2f\n",normal.dotProduct(tst),normal.distance(tst),test);*/

//scalar p = DotProduct( plane->normal, destPt ) + plane->distance;
//printf("test -> %.2f\n",t1.dotProduct()+);
	init();

	while(!done)
	{
		timer.update();
		draw();
		input();

		if (timer.getTime() >= demoEnd)
		{
			done = true;
		}
	}

	//end cleaning
	sound.close();

	for(int i = 0; i < MAX_SCENES; i++)
	{
		delete scene[i];
	}

#ifdef SDL
	SDL_Quit();
#endif

	return EXIT_SUCCESS;
}
