#ifndef SCENE_H
#define SCENE_H

#include "graphics.h"
#include "camera.h"
#include "timer.h"
#include "vector.h"

class Scene {
protected:
	int timeBegin, timeEnd, currentCamera;
	float timePosition;
	Camera* camera[8];
public:
	Scene(int timeBegin, int timeEnd);
	virtual ~Scene(void)
	{
		for(int i = 0; i < 8; i++)
		{
			if (camera[i] != NULL)
			{
				delete camera[i];
			}
		}
	}

	void update(void);
	virtual void renderScene(void) = 0;
};

#endif
