#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sound.h"

Sound sound;

#ifndef FMOD
//Since we're using MiniFMOD the song is
//going to be loaded from song.h' "char * data" variable
//...fucking ace :-)
#include "song.h"

typedef struct
{
	int length;
	int pos;
	void *data;
}
MEMFILE;

unsigned int memopen(char *name)
{
	MEMFILE *memfile;
	memfile = (MEMFILE *)calloc(sizeof(MEMFILE),1);
	{
		memfile->length = songlength;
		memfile->data = calloc(memfile->length,1);
		memcpy(memfile->data, (void*)song, memfile->length);
		memfile->pos = 0;
	}
	return((unsigned int)memfile);
}

void memclose(unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE *)handle;
	free(memfile->data);
	free(memfile);
}

int memread(void *buffer, int size, unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE *)handle;

	if (memfile->pos + size >= memfile->length)
	{
		size = memfile->length - memfile->pos;
	}

	memcpy(buffer, (char *)memfile->data+memfile->pos, size);
	memfile->pos += size;

	return(size);
}

void memseek(unsigned int handle, int pos, signed char mode)
{
	MEMFILE *memfile = (MEMFILE *)handle;

	if (mode == SEEK_SET)
	{
		memfile->pos = pos;
	}
	else if (mode == SEEK_CUR)
	{
		memfile->pos += pos;
	}
	else if (mode == SEEK_END)
	{
		memfile->pos = memfile->length + pos;
	}

	if (memfile->pos > memfile->length)
	{
		memfile->pos = memfile->length;
	}
}

int memtell(unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE *)handle;
	return(memfile->pos);
}
#endif

int Sound::getOrder()
{
#ifdef FMOD
	FMOD_Channel_GetPosition(channel, &fmod_sync, FMOD_TIMEUNIT_MODORDER);
	return fmod_sync;
#else
	return FMUSIC_GetOrder(mod);
#endif
}

int Sound::getRow()
{
#ifdef FMOD
	FMOD_Channel_GetPosition(channel, &fmod_sync, FMOD_TIMEUNIT_MODROW);
	return fmod_sync;
#else
	return FMUSIC_GetRow(mod);
#endif
}

void Sound::init()
{
#ifdef FMOD
	fsound = 0;
	FMOD_System_Create(&system);
	FMOD_System_Init(system, 1, FMOD_INIT_NORMAL, NULL);
	FMOD_System_CreateSound(system, "music.xm", FMOD_SOFTWARE | FMOD_CREATESTREAM, 0, &fsound);

	FMOD_System_PlaySound(system, FMOD_CHANNEL_FREE, fsound, 0, &channel);
#else
	FSOUND_File_SetCallbacks(memopen, memclose, memread, memseek, memtell);
	FSOUND_Init(44100, 0);
	mod = FMUSIC_LoadSong("music.xm", NULL);

	FMUSIC_PlaySong(mod);
#endif
}

void Sound::close()
{
#ifdef FMOD
	FMOD_Sound_Release(fsound);
	FMOD_System_Close(system);
	FMOD_System_Release(system);
#else
	FMUSIC_FreeSong(mod);
	FSOUND_Close();
#endif
}
