#include "timer.h"
#include "graphics.h"

Timer timer;

#ifdef DEBUG
void Timer::getFPS(void)
{
	frames++;
	if (time - oldTime >= 1000)
	{
		//use float if you want more accurate
		//form but int should be just fine
		int fps = frames / ((time - oldTime) / 1000);

		//FPS is displayed in the window title
		char title[64];
		sprintf(title, "ExHouse's Fuzzy Lhamas - FPS : %d", fps);
		SDL_WM_SetCaption(title, 0);

		oldTime = time;
		frames = 0;
	}
}
#endif

void Timer::init(void)
{
	start = SDL_GetTicks();
#ifdef DEBUG
	frames = oldTime = 0;
#endif
}

void Timer::update(void)
{
	SDL_Delay(1);
	time = SDL_GetTicks() - start;
#ifdef DEBUG
	getFPS();
#endif
}

int Timer::getTime(void)
{
	return time;
}
