#ifndef VECTOR_H
#define VECTOR_H

class Vector {
public:
	float x, y, z;
	Vector(void);
	Vector(const Vector& vec);
	Vector(float x, float y, float z);
	float length(void);
	float distance(const Vector& vec);
	Vector normalize(void);
	float dotProduct(const Vector& vec);
	Vector crossProduct(const Vector& vec);
	Vector normal(const Vector& vec2, const Vector& vec3);
	float angle(Vector& vec);
	bool operator == (const Vector& vec);
	void operator = (const Vector& vec);
	Vector operator + (const Vector& vec);
	Vector operator += (const Vector& vec);
	Vector operator - (const Vector& vec);
	Vector operator -= (const Vector& vec);
	Vector operator * (const float& a);
	Vector operator *= (const float& a);
	Vector operator / (const float& a);
	Vector operator /= (const float& a);
};

#endif
